var ColorPalette = {
    // 차트 제외, 컬러 파레드
    common: {
        officialLabelColors: [
            "#a4c6ff", // 데이터 :: data
            "#e5603b", // 선택된 :: selected
            "#E49400", // 유틸   :: util
            "#2477FF", // 저장   :: save
            "#2D8515", // 수정   :: update
            "#DB2A34"  // 삭제   :: delete
        ],
        reqStateColor: [
            "rgba(219, 42, 52, 0.7)", // 열림
            "rgba(228, 148, 0, 0.7)", // 진행중
            "rgba(45, 133, 21, 0.7)", // 해결됨
            "rgba(36, 119, 255,0.7)"  // 닫힘
        ]
    },
    // eCharts 컬러 - "차트이름+Chart"
    eCharts: {
        radialPolarBarChart:[
            "rgba(227,26,27,0.66)",
            "rgba(55,125,184,0.62)",
            "rgba(77,175,74,0.65)",
            "rgba(255,127,0,0.7)",
            "rgba(255,255,51,0.71)",
            "rgba(151,78,163,0.73)",
            "rgba(166,86,40,0.7)"
        ],
        pieChart:[
            'rgba( 84, 112, 198, 0.8)',  // 파란색
            'rgba(145, 204, 117, 0.8)',  // 초록색
            'rgba(250, 200,  88, 0.8)',  // 노란색
            'rgba(238, 102, 102, 0.8)',  // 빨간색
            'rgba(115, 192, 222, 0.8)',  // 하늘색
            'rgba( 59, 162, 114, 0.8)',  // 짙은 초록색
            'rgba(252, 132,  82, 0.8)',  // 오렌지색
            'rgba(154, 96,  180, 0.8)',  // 보라색
            'rgba(234, 124, 204, 0.8)',  // 분홍색
            'rgba( 50,  90, 180, 0.8)',  // 짙은 파란색
            'rgba(120, 170, 100, 0.8)',  // 짙은 초록색
            'rgba(230, 180,  70, 0.8)',  // 짙은 노란색
            'rgba(200,  80,  80, 0.8)',  // 짙은 빨간색
            'rgba(100, 160, 200, 0.8)',  // 짙은 하늘색
            'rgba( 40, 130,  90, 0.8)',  // 짙은 짙은 초록색
            'rgba(230, 110,  60, 0.8)',  // 짙은 오렌지색
            'rgba(130,  80, 160, 0.8)',  // 짙은 보라색
            'rgba(210, 100, 180, 0.8)',   // 짙은 분홍색
            'rgba(120, 160, 230, 0.8)',  // 연파란색
            'rgba(180, 230, 150, 0.8)',  // 연초록색
            'rgba(255, 230, 130, 0.8)',  // 연노란색
            'rgba(245, 140, 140, 0.8)',  // 연빨간색
            'rgba(150, 215, 240, 0.8)',  // 연하늘색
            'rgba(100, 190, 140, 0.8)',  // 연짙은 초록색
            'rgba(255, 160, 110, 0.8)',  // 연오렌지색
            'rgba(190, 130, 210, 0.8)'   // 연보라색
            // 'rgba(245, 160, 220, 0.8)'// 연분홍색(etc 고정)
        ]
    },
    // d3 Chart(c3 포함) 컬러 - "차트이름+Chart"
    d3Chart: {
        combinationChart: [
            "rgba(227,26,27,0.65)",
            "rgba(255,127,0,0.75)",
            "rgba(192,192,128,0.8)",
            "rgba(77,175,74,0.7)",
            "rgba(55,125,184,0.8)",
            "rgba(151,78,163,0.8)",
            "rgba(166,86,40,0.8)",
            "rgba(192,128,96,0.8)",
            "rgba(64,128,224,0.7)",
            "rgba(64,160,64,0.7)",
            "rgba(224,0,224,0.7)",
            "rgba(245,235,51,0.75)",
            "rgba(160,96,224,0.8)",
            "rgba(128,64,0,0.8)"
        ],
        timeLineChart: [
            "rgba(158, 1, 66, 0.65)",
            "rgba(213, 62, 79, 0.65)",
            "rgba(244, 109, 67, 0.65)",
            "rgba(253, 174, 97, 0.65)",
            "rgba(254, 224, 139, 0.65)",
            "rgba(230, 245, 152, 0.65)",
            "rgba(171, 221, 164, 0.65)",
            "rgba(102, 194, 165, 0.65)",
            "rgba(50, 136, 189, 0.65)",
            "rgba(94, 79, 162, 0.65)"
        ],
        gaugeChart: [
            "rgba(158, 1, 66, 0.8)",
            "rgba(213, 62, 79, 0.8)",
            "rgba(244, 109, 67, 0.8)",
            "rgba(253, 174, 97, 0.8)",
            "rgba(254, 224, 139, 0.8)",
            "rgba(230, 245, 152, 0.8)",
            "rgba(171, 221, 164, 0.8)",
            "rgba(102, 194, 165, 0.8)",
            "rgba(50, 136, 189, 0.8)",
            "rgba(94, 79, 162, 0.8)"
        ],
        horizontalChart:[
            "rgba(253, 174, 97, 0.65)"
        ],
        sankeyChart:[
            '#1774e5',
            '#e3cc85',
            '#17cde5',
            '#e5db17'
        ]
    },
    // 기타 차트 라이브러리
    otherChartLib: {
        treeMapChart: [
            "rgba(171, 221, 164, 0.65)",
            "rgba( 77, 175,  74, 0.7)",
            "rgba(253, 174,  97, 0.65)",
            "rgba(244, 109,  67, 0.65)",
            "rgba(102, 194, 165, 0.65)",
            "rgba(230, 245, 152, 0.65)",
            "rgba(192, 128,  96, 0.7)",
            "rgba(166,  86,  40, 0.7)",
            "rgba( 50, 136, 189, 0.65)",
            "rgba( 94,  79, 162, 0.65)",
            "rgba(158,   1,  66, 0.65)",
            "rgba(213,  62,  79, 0.65)",
            "rgba(244, 109,  67, 0.65)",
            "rgba(253, 174,  97, 0.65)",
            "rgba(254, 224, 139, 0.65)",
            "rgba(230, 245, 152, 0.65)",
            // base 에서 b 1씩 감소
            "rgba(171, 221, 163, 0.65)",
            "rgba(102, 194, 164, 0.65)",
            "rgba(171, 221, 162, 0.65)",
            "rgba( 77, 175,  73, 0.7)",
            "rgba(253, 174,  96, 0.65)",
            "rgba(244, 109,  66, 0.65)",
            "rgba(102, 194, 164, 0.65)",
            "rgba(230, 245, 151, 0.65)",
            "rgba(192, 128,  95, 0.7)",
            "rgba(166,  86,  39, 0.7)",
            "rgba( 50, 136, 188, 0.65)",
            "rgba( 94,  79, 161, 0.65)",
            "rgba(158,   1,  65, 0.65)",
            "rgba(213,  62,  78, 0.65)",
            "rgba(244, 109,  66, 0.65)",
            "rgba(253, 174,  96, 0.65)",
            "rgba(254, 224, 138, 0.65)",
            "rgba(230, 245, 151, 0.65)",
            // base 에서 g 1씩 감소
            "rgba(171, 220, 164, 0.65)",
            "rgba(102, 193, 165, 0.65)",
            "rgba(171, 220, 164, 0.65)",
            "rgba( 77, 174,  74, 0.7)",
            "rgba(253, 173,  97, 0.65)",
            "rgba(244, 108,  67, 0.65)",
            "rgba(102, 193, 165, 0.65)",
            "rgba(230, 244, 152, 0.65)",
            "rgba(192, 127,  96, 0.7)",
            "rgba(166,  85,  40, 0.7)",
            "rgba( 50, 135, 189, 0.65)",
            "rgba( 94,  78, 162, 0.65)",
            "rgba(158, 0,    66, 0.65)",
            "rgba(213, 61,   79, 0.65)",
            "rgba(244, 108,  67, 0.65)",
            "rgba(253, 173,  97, 0.65)",
            "rgba(254, 223, 139, 0.65)",
            "rgba(230, 244, 152, 0.65)",
            // base 에서 r 1씩 감소
            "rgba(170, 221, 164, 0.65)",
            "rgba(101, 194, 165, 0.65)",
            "rgba(170, 221, 164, 0.65)",
            "rgba( 76, 175,  74, 0.7)",
            "rgba(252, 174,  97, 0.65)",
            "rgba(243, 109,  67, 0.65)",
            "rgba(101, 194, 165, 0.65)",
            "rgba(229, 245, 152, 0.65)",
            "rgba(191, 128,  96, 0.7)",
            "rgba(165,  86,  40, 0.7)",
            "rgba( 49, 136, 189, 0.65)",
            "rgba( 93,  79, 162, 0.65)",
            "rgba(157,   1,  66, 0.65)",
            "rgba(212,  62,  79, 0.65)",
            "rgba(243, 109,  67, 0.65)",
            "rgba(252, 174,  97, 0.65)",
            "rgba(253, 224, 139, 0.65)",
            "rgba(229, 245, 152, 0.65)",
            // 위 세트에서 투명도 0.01추가
            "rgba(171, 221, 164, 0.66)",
            "rgba( 77, 175,  74, 0.71)",
            "rgba(253, 174,  97, 0.66)",
            "rgba(244, 109,  67, 0.66)",
            "rgba(102, 194, 165, 0.66)",
            "rgba(230, 245, 152, 0.66)",
            "rgba(192, 128,  96, 0.71)",
            "rgba(166,  86,  40, 0.71)",
            "rgba( 50, 136, 189, 0.66)",
            "rgba( 94,  79, 162, 0.66)",
            "rgba(158,   1,  66, 0.66)",
            "rgba(213,  62,  79, 0.66)",
            "rgba(244, 109,  67, 0.66)",
            "rgba(253, 174,  97, 0.66)",
            // base 에서 b 1씩 감소
            "rgba(171, 221, 163, 0.66)",
            "rgba(102, 194, 164, 0.66)",
            "rgba(171, 221, 162, 0.66)",
            "rgba( 77, 175,  73, 0.71)",
            "rgba(253, 174,  96, 0.66)",
            "rgba(244, 109,  66, 0.66)",
            "rgba(102, 194, 164, 0.66)",
            "rgba(230, 245, 151, 0.66)",
            "rgba(192, 128,  95, 0.71)",
            "rgba(166,  86,  39, 0.71)",
            "rgba( 50, 136, 188, 0.66)",
            "rgba( 94,  79, 161, 0.66)",
            "rgba(158,   1,  65, 0.66)",
            "rgba(213,  62,  78, 0.66)",
            "rgba(244, 109,  66, 0.66)",
            "rgba(253, 174,  96, 0.66)",
            "rgba(254, 224, 138, 0.66)",
            "rgba(230, 245, 151, 0.66)",
            // base 에서 g 1씩 감소
            "rgba(171, 220, 164, 0.66)",
            "rgba(102, 193, 165, 0.66)",
            "rgba(171, 220, 164, 0.66)",
            "rgba( 77, 174,  74, 0.71)",
            "rgba(253, 173,  97, 0.66)",
            "rgba(244, 108,  67, 0.66)",
            "rgba(102, 193, 165, 0.66)",
            "rgba(230, 244, 152, 0.66)",
            "rgba(192, 127,  96, 0.71)",
            "rgba(166,  85,  40, 0.71)",
            "rgba( 50, 135, 189, 0.66)",
            "rgba( 94,  78, 162, 0.66)",
            "rgba(158, 0,    66, 0.66)",
            "rgba(213, 61,   79, 0.66)",
            "rgba(244, 108,  67, 0.66)",
            "rgba(253, 173,  97, 0.66)",
            "rgba(254, 223, 139, 0.66)",
            "rgba(230, 244, 152, 0.66)",
            // base 에서 r 1씩 감소
            "rgba(170, 221, 164, 0.66)",
            "rgba(101, 194, 165, 0.66)",
            "rgba(170, 221, 164, 0.66)",
            "rgba( 76, 175,  74, 0.71)",
            "rgba(252, 174,  97, 0.66)",
            "rgba(243, 109,  67, 0.66)",
            "rgba(101, 194, 165, 0.66)",
            "rgba(229, 245, 152, 0.66)",
            "rgba(191, 128,  96, 0.71)",
            "rgba(165,  86,  40, 0.71)",
            "rgba( 49, 136, 189, 0.66)",
            "rgba( 93,  79, 162, 0.66)",
            "rgba(157,   1,  66, 0.66)",
            "rgba(212,  62,  79, 0.66)",
            "rgba(243, 109,  67, 0.66)",
            "rgba(252, 174,  97, 0.66)",
            "rgba(253, 224, 139, 0.66)",
            "rgba(229, 245, 152, 0.66)",
        ]
    }
};
